<?php


namespace Ardent\GrocyApi\Objects;


use Symfony\Component\Serializer\Annotation\Ignore;

abstract class AbstractApiObject
{
    private int $id;

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @param int $id
     *
     * @return ProductsObject
     */
    public function setId(int $id): AbstractApiObject
    {
        $this->id = $id;
        return $this;
    }

    #[Ignore]
    abstract public static function getEntity(): string;
}