<?php

namespace Ardent\GrocyApi\Objects;

use Symfony\Component\Serializer\Annotation\Ignore;

class ProductsObject extends AbstractApiObject
{
    private string $name;

    private string $description;

    private int $min_stock_amount = 0;

    private int $location_id;

    private int $qu_id_stock;

    private int $qu_id_purchase;

    private int $qu_factor_purchase_to_stock;

    #[Ignore]
    private array $userfields;

    public static function getEntity(): string
    {
        return 'products';
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @param string $name
     *
     * @return ProductsObject
     */
    public function setName(string $name): ProductsObject
    {
        $this->name = $name;
        return $this;
    }

    /**
     * @return string
     */
    public function getDescription(): string
    {
        return $this->description;
    }

    /**
     * @param string $description
     *
     * @return ProductsObject
     */
    public function setDescription(string $description): ProductsObject
    {
        $this->description = $description;
        return $this;
    }

    /**
     * @return int
     */
    public function getMinStockAmount(): int
    {
        return $this->min_stock_amount;
    }

    /**
     * @param int $min_stock_amount
     *
     * @return ProductsObject
     */
    public function setMinStockAmount(int $min_stock_amount): ProductsObject
    {
        $this->min_stock_amount = $min_stock_amount;
        return $this;
    }

    /**
     * @return array
     */
    public function getUserfields(): array
    {
        return $this->userfields;
    }

    /**
     * @param array $userfields
     *
     * @return ProductsObject
     */
    public function setUserfields(array $userfields): ProductsObject
    {
        $this->userfields = $userfields;
        return $this;
    }

    /**
     * @return int
     */
    public function getLocationId(): int
    {
        return $this->location_id;
    }

    /**
     * @param int $location_id
     *
     * @return ProductsObject
     */
    public function setLocationId(int $location_id): ProductsObject
    {
        $this->location_id = $location_id;
        return $this;
    }

    /**
     * @return int
     */
    public function getQuIdStock(): int
    {
        return $this->qu_id_stock;
    }

    /**
     * @param int $qu_id_stock
     *
     * @return ProductsObject
     */
    public function setQuIdStock(int $qu_id_stock): ProductsObject
    {
        $this->qu_id_stock = $qu_id_stock;
        return $this;
    }

    /**
     * @return int
     */
    public function getQuIdPurchase(): int
    {
        return $this->qu_id_purchase;
    }

    /**
     * @param int $qu_id_purchase
     *
     * @return ProductsObject
     */
    public function setQuIdPurchase(int $qu_id_purchase): ProductsObject
    {
        $this->qu_id_purchase = $qu_id_purchase;
        return $this;
    }

    /**
     * @return int
     */
    public function getQuFactorPurchaseToStock(): int
    {
        return $this->qu_factor_purchase_to_stock;
    }

    /**
     * @param int $qu_factor_purchase_to_stock
     *
     * @return ProductsObject
     */
    public function setQuFactorPurchaseToStock(int $qu_factor_purchase_to_stock): ProductsObject
    {
        $this->qu_factor_purchase_to_stock = $qu_factor_purchase_to_stock;
        return $this;
    }
}