<?php

namespace Ardent\GrocyApi\Objects;

use Symfony\Component\Serializer\Annotation\Ignore;

class QuantityUnitsObject extends AbstractApiObject
{
    private string $name;

    private ?string $description;

    private string $row_created_timestamp;

    private string $name_plural;

    public static function getEntity(): string
    {
        return 'quantity_units';
    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @param string $name
     *
     * @return QuantityUnitsObject
     */
    public function setName(string $name): QuantityUnitsObject
    {
        $this->name = $name;
        return $this;
    }

    /**
     * @return string|null
     */
    public function getDescription(): ?string
    {
        return $this->description;
    }

    /**
     * @param string|null $description
     *
     * @return QuantityUnitsObject
     */
    public function setDescription(?string $description): QuantityUnitsObject
    {
        $this->description = $description;
        return $this;
    }

    /**
     * @return string
     */
    public function getRowCreatedTimestamp(): string
    {
        return $this->row_created_timestamp;
    }

    /**
     * @param string $row_created_timestamp
     *
     * @return QuantityUnitsObject
     */
    public function setRowCreatedTimestamp(string $row_created_timestamp): QuantityUnitsObject
    {
        $this->row_created_timestamp = $row_created_timestamp;
        return $this;
    }

    /**
     * @return string
     */
    public function getNamePlural(): string
    {
        return $this->name_plural;
    }

    /**
     * @param string $name_plural
     *
     * @return QuantityUnitsObject
     */
    public function setNamePlural(string $name_plural): QuantityUnitsObject
    {
        $this->name_plural = $name_plural;
        return $this;
    }
}